package space.eptaproject.vmodextras.block;

import edn.stratodonut.trackwork.tracks.forces.PhysicsTrackController;
import edn.stratodonut.trackwork.tracks.forces.SimpleWheelController;
import net.minecraft.core.BlockPos;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.block.state.BlockState;
import org.joml.Vector3d;
import org.joml.Vector3dc;
import org.valkyrienskies.core.api.ships.ServerShip;
import org.valkyrienskies.mod.common.VSGameUtilsKt;
import space.eptaproject.vmodextras.trackwork.IPhysicsTrackController;
import space.eptaproject.vmodextras.trackwork.ISimpleWheelController;
import space.eptaproject.vmodextras.Vmodaddon;
import space.eptaproject.vmodextras.util.IBlockEntityClear;

public class TrackBackupBlockEntity extends BlockEntity implements IBlockEntityClear {
    public TrackBackupBlockEntity(BlockPos p_155229_, BlockState p_155230_) {
        super(Vmodaddon.MY_BLOCK_ENTITY.get(), p_155229_, p_155230_);
    }

    public CompoundTag tag = new CompoundTag();

    @Override
    public boolean clear() {
        try {
            CompoundTag local = tag.copy();
            if (local.contains("SimpleWheelController")) {
                CompoundTag SimpleWheelControllerTag = new CompoundTag();

                SimpleWheelControllerTag.putFloat("SuspensionStiffness", 1);
                {
                    CompoundTag suspensionAdjust = new CompoundTag();

                    suspensionAdjust.putDouble("x", 0);
                    suspensionAdjust.putDouble("y", 1);
                    suspensionAdjust.putDouble("z", 0);

                    SimpleWheelControllerTag.put("suspensionAdjust", suspensionAdjust);
                }

                tag.put("SimpleWheelController", SimpleWheelControllerTag);
            }

            if (local.contains("PhysicsTrackController")) {
                CompoundTag PhysicsTrackControllerTag = new CompoundTag();

                PhysicsTrackControllerTag.putFloat("SuspensionStiffness", 1);
                {
                    CompoundTag suspensionAdjust = new CompoundTag();


                    suspensionAdjust.putDouble("x", 0);
                    suspensionAdjust.putDouble("y", 1);
                    suspensionAdjust.putDouble("z", 0);

                    PhysicsTrackControllerTag.put("suspensionAdjust", suspensionAdjust);
                }

                tag.put("PhysicsTrackController", PhysicsTrackControllerTag);
            }
            return true;
        } catch (Exception e) {
            return false;
        }
    }

    @Override
    protected void saveAdditional(CompoundTag tag) {
        this.tag = tag;
        super.saveAdditional(tag);
        ServerShip ship = (ServerShip) VSGameUtilsKt.getShipObjectManagingPos(this.level, getBlockPos());
        if (ship != null) {
            {
                PhysicsTrackController physicsTrackController = ship.getAttachment(PhysicsTrackController.class);
                IPhysicsTrackController controller = (IPhysicsTrackController) physicsTrackController;
                if (physicsTrackController != null) {
                    CompoundTag PhysicsTrackControllerTag = new CompoundTag();

                    PhysicsTrackControllerTag.putFloat("SuspensionStiffness", controller.getSuspensionStiffness());
                    {
                        CompoundTag suspensionAdjust = new CompoundTag();

                        Vector3dc vec = controller.getSuspensionAdjust();

                        suspensionAdjust.putDouble("x", vec.x());
                        suspensionAdjust.putDouble("y", vec.y());
                        suspensionAdjust.putDouble("z", vec.z());

                        PhysicsTrackControllerTag.put("suspensionAdjust", suspensionAdjust);
                    }

                    tag.put("PhysicsTrackController", PhysicsTrackControllerTag);
                }
            }

            {
                SimpleWheelController simpleWheelController = ship.getAttachment(SimpleWheelController.class);
                ISimpleWheelController controller = (ISimpleWheelController) simpleWheelController;
                if (simpleWheelController != null) {
                    CompoundTag SimpleWheelControllerTag = new CompoundTag();

                    SimpleWheelControllerTag.putFloat("SuspensionStiffness", controller.getSuspensionStiffness());
                    {
                        CompoundTag suspensionAdjust = new CompoundTag();

                        Vector3dc vec = controller.getSuspensionAdjust();

                        suspensionAdjust.putDouble("x", vec.x());
                        suspensionAdjust.putDouble("y", vec.y());
                        suspensionAdjust.putDouble("z", vec.z());

                        SimpleWheelControllerTag.put("suspensionAdjust", suspensionAdjust);
                    }

                    tag.put("SimpleWheelController", SimpleWheelControllerTag);
                }
            }
        }
    }

    @Override
    public void load(CompoundTag tag) {
        this.tag = tag;
        super.load(tag);

        ServerShip ship = (ServerShip) VSGameUtilsKt.getShipObjectManagingPos(this.level, getBlockPos());
        if (ship != null) {
            if (tag.contains("SimpleWheelController")) {
                CompoundTag L = tag.getCompound("SimpleWheelController");
                SimpleWheelController controller2 = SimpleWheelController.getOrCreate(ship);
                if (L.contains("SuspensionStiffness")) {
                    ((ISimpleWheelController) controller2).setSuspensionStiffness(L.getFloat("SuspensionStiffness"));
                }
                if (L.contains("suspensionAdjust")) {
                    CompoundTag suspensionAdjust = L.getCompound("suspensionAdjust");

                    ((ISimpleWheelController) controller2).setSuspensionAdjust(new Vector3d(new Vector3d(suspensionAdjust.getDouble("x"), suspensionAdjust.getDouble("y"), suspensionAdjust.getDouble("z"))));
                }
            }

            if (tag.contains("PhysicsTrackController")) {
                CompoundTag L = tag.getCompound("PhysicsTrackController");
                PhysicsTrackController controller = PhysicsTrackController.getOrCreate(ship);
                if (L.contains("SuspensionStiffness")) {
                    ((IPhysicsTrackController) controller).setSuspensionStiffness(L.getFloat("SuspensionStiffness"));
                }
                if (L.contains("suspensionAdjust")) {
                    CompoundTag suspensionAdjust = L.getCompound("suspensionAdjust");


                    ((IPhysicsTrackController) controller).setSuspensionAdjust(new Vector3d(suspensionAdjust.getDouble("x"), suspensionAdjust.getDouble("y"), suspensionAdjust.getDouble("z")));
                }
            }
        }
    }
}
